Subject: Ftp-WG: transfers of \r, \n, \r\n

From: Pat LaVarre <[email-masked]>
Date: Fri, 18 Jan 2002 20:00:05 -0500

> > > The rules for an "NVT-ASCII" DATA connection
> > > appear less clear to me, in particular ... NLST

> [email-masked] 01/18/02 17:20 PM
> Telnet protocol only applies
> to the command channel not the data channel.

Thanks for listening, thanks for answering, but ...

Too fast for me, sorry.

Can you say again specifically how the rfc's require a
local \r, \n, and \r\n to pass thru a "TYPE A"scii
data connection?

Myself I can read rfc959 many, many different ways
here: many equally credible.

You can't mean to say local \r, \n, \r\n should pass
thru a "TYPE A"scii data connection unchanged - can
you?  I thought "everyone" did agree at least the
locally preferred Eol changes en route?

I wonder if "everyone knows" that rfc959 means ...

> > http://www.ietf.org/rfc/rfc959.txt [Ftp]
...
> > 3.  DATA TRANSFER FUNCTIONS
> > 3.1.  DATA REPRESENTATION AND STORAGE
> > 3.1.1.  DATA TYPES
> > 3.1.1.1.  ASCII TYPE
...
> > the default type ... intended primarily
> > for the transfer of text files ...

i.e. intended primarily intended for the exchange of
the bytes %x20-7E.  Little thought, less comment re
what happens to bytes %x00-1F and %x7F-FF.

> > The sender converts the data from an internal
> > character representation to the standard 8-bit
> > NVT-ASCII representation
> > (see the Telnet specification).

i.e. portions of rfc854 [Telnet] do apply to the data
connection.  In particular: \r may appear only as \r\0
or as \r\n, and \xFF may appear only as \xFF\xFF, but
all other bytes may appear in any ordering.

> > The receiver will convert the data
> > from the standard form
> > to his own internal form.

i.e. the <CRLF> sequence should change into the
locally preferred Eol at the receiving end.

> > In accordance with the NVT standard,
> > the <CRLF> sequence should be used
> > where necessary to denote
> > the end of a line of text.

i.e. at the sending end the locally preferred Eol
should pass into a "TYPE A"scii data connection as the
<CRLF> sequence.

> > (See the discussion of file structure
> > at the end of the Section on
> > Data Representation and Storage.)

Personally I've failed to click thru this link with
much confidence, but just guessing:

> > 3.1.2.1.  FILE STRUCTURE
> >
> > File structure is the default
> > to be assumed if the STRUcture command
> > has not been used.
> >
> > In file-structure
> > there is no internal structure
> > and the file is considered
> > to be a continuous sequence of data bytes.

Not especially meaningful - this a declaration of a
conscious neglect to require work.

> > > The rules for an "NVT-ASCII" DATA connection
> > > appear less clear to me, in particular ... NLST
...
> > > Can you say again specifically
> > > how the rfc's require a local \r, \n, and \r\n
> > > to pass thru a "TYPE A"scii data connection?

Unless we can answer this, we can't say how to NLST or
MLST a pathname that includes \r or \n: we can only
say how to MLSD it.

Thanks again in advance.    Pat LaVarre

__________________________________________________
Do You Yahoo!?
Send FREE video emails in Yahoo! Mail!
http://promo.yahoo.com/videomail/